unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, HddInfo;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Inf: TMemo;
    cb: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    hdd: THDDInfo;
    DName: TComboBox;
    Label3: TLabel;
    Port: TEdit;
    Button2: TButton;
    Label4: TLabel;
    gim: TComboBox;
    Label5: TLabel;
    EOs: TEdit;
    Canonic: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}



procedure TMainForm.Button1Click(Sender: TObject);
procedure NonZero(txt:string; val:integer; txt2:string='');
begin
 if val > 0 then  inf.Lines.Add(txt+inttostr(val)+txt2);
end;
begin
 inf.Clear;
 hdd.CanonicalScsiAddressing := canonic.Checked;

 try
  hdd.Method := TGetInfoMethod(gim.itemindex);
  if hdd.Method = gimByName then
  begin
   if dname.Text = '' then
   begin
    ShowMessage('Device name not specified!');
    exit;
   end;
   hdd.DeviceName := DName.Text;
  end
  else
  begin
   hdd.Drive := TDrive(cb.itemindex);
  end; 

  if hdd.isIDE then inf.Lines.Add(cb.Text)
  else inf.Lines.Add('Device '+hdd.DeviceName+':');

  case hdd.HDDType of
   dtFixed:
   begin
    inf.Lines.Add('Type:                   Fixed');
    if hdd.isIDE then
    begin
     NonZero('LBA sectors:            ',hdd.LBASectors);
     NonZero('Cylinders:              ',hdd.CylsTotal);
     NonZero('Heads:                  ',hdd.HeadTotal);
     NonZero('Tracks:                 ',hdd.CylsTotal * hdd.HeadTotal);
     NonZero('Sectors per track:      ',hdd.SPT);
     NonZero('Size:                   ',hdd.Size shr 20,' Mb');
     NonZero('Controller buffer size: ',hdd.BufSize shr 10,' Kb');
     NonZero('ECC Code:               ',hdd.ECC);
    end
   end;
   dtCDROM:     inf.Lines.Add('Type:                   CDROM Device');
   dtRemovable: inf.Lines.Add('Type:                   Removable');
   dtTape:      inf.Lines.Add('Type:                   Tape Device');
   dtOptical:   inf.Lines.Add('Type:                   Optical Device');
   dtArray:     inf.Lines.Add('Type:                   Array Device');
   dtUnknown:   inf.Lines.Add('Type:                   Unknown');
  end;


  if hdd.Model <> '' then
  inf.Lines.Add('Model:                  '+hdd.Model);

  if hdd.Revision <> '' then
  inf.Lines.add('Firmware Revision:      '+hdd.Revision);

  if hdd.Serial <> '' then
  inf.Lines.add('Serial Number:          '+hdd.Serial);
 except
  inf.Lines.add('No device');
 end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var i,j:integer;
begin
 inf.Clear;
  try
  hdd.ScsiPort := strtointdef(port.Text,0);
  inf.Lines.Add('Scsi Port: '+inttostr(hdd.ScsiPort));
  inf.Lines.Add(' Bus count: '+inttostr(hdd.ScsiBusCount));
  for i := 0 to hdd.ScsiBusCount - 1 do
  begin
   hdd.ScsiBus := i;
   inf.Lines.Add('  Scsi Bus: '+inttostr(i));
   inf.Lines.Add('   Device count: '+inttostr(hdd.ScsiDevCount));
   for j := 0 to hdd.ScsiDevCount - 1 do
   begin
     hdd.ScsiDevice := j;
     inf.Lines.Add('    Device '+inttostr(j));

     if hdd.ScsiInfo.Model <> '' then
                   inf.Lines.Add('     Model:           '+hdd.ScsiInfo.Model);
     if hdd.ScsiInfo.Revision <> '' then
                   inf.Lines.add('     Firmware Rev.:   '+hdd.ScsiInfo.Revision);
     if hdd.ScsiInfo.Serial <> '' then
                   inf.Lines.add('     Serial Number:   '+hdd.ScsiInfo.Serial);
     inf.Lines.Add('     PathId:          '+inttostr(hdd.ScsiInfo.PathId));
     inf.Lines.Add('     TargetId:        '+inttostr(hdd.ScsiInfo.TargetId));
     inf.Lines.Add('     Lun:             '+inttostr(hdd.ScsiInfo.Lun));
     if hdd.isNT then
     if hdd.ScsiInfo.DeviceClaimed then
      inf.Lines.Add('     Device claimed:  yes')
     else
      inf.Lines.Add('     Device claimed:  no');
     case hdd.ScsiInfo.HDDType of
      dtFixed:     inf.Lines.Add('     Type:            Fixed');
      dtCDROM:     inf.Lines.Add('     Type:            CDROM Device');
      dtRemovable: inf.Lines.Add('     Type:            Removable');
      dtTape:      inf.Lines.Add('     Type:            Tape Device');
      dtOptical:   inf.Lines.Add('     Type:            Optical Device');
      dtArray:     inf.Lines.Add('     Type:            Array Device');
      dtUnknown:   inf.Lines.Add('     Type:            Unknown');
     end;
     inf.Lines.Add('');
   end;
  end;
  except
    on E:exception do
    begin
     inf.Lines.Add(E.Message);
     exit;
    end;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
 if hdd.isNT then EOs.Text := 'WinNT' else EOs.Text := 'Win9x';
end;

end.
